//=============================================================================
// Change_MultiBlade_MZ.js
//   Last update: 2024/09/22
//=============================================================================
// 更新っぽいもの
// 
// 2024/09/22 [v0.1.0]
// 初版

/*:
 * @target MZ
 * 
 * @plugindesc
 * [v0.1.0] Change!! MultiBlade MZ.
 * 
 * @author Diamond
 *
 * @param Weapon Slot 2
 * @text ????
 * @default 2
 * @type number
 * @min 2
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Weapon Slot 3
 * @text ????
 * @default 6
 * @type number
 * @min 2
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Weapon Slot 4
 * @text ????
 * @default 9
 * @type number
 * @min 2
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Shild Slot ID
 * @text ????
 * @default 2
 * @type number
 * @min 2
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Shild Slot 2
 * @text ????
 * @default 3
 * @type number
 * @min 2
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Acce Slot ID
 * @text ????
 * @default 6
 * @type number
 * @min 2
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Acce Slot 2
 * @text ????
 * @default 7
 * @type number
 * @min 2
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 * 
 * @help
 * Diamond use ruby, not use Java Script!!
 * Please use Ruby!! and RPG Tkool XP/VX/VX Ace.
 * 
 * @url https://diamond.iza-yoi.net/
 */

/*:ja
 * @target MZ
 * 
 * @plugindesc
 * [v0.1.0] 真（チェンジ！！）多刀流 MZ
 * 
 * @author 貪藻矢射妥←
 *
 * @param Weapon Slot 2
 * @text 多刀流・二つ目の武器スロット
 * @default 2
 * @type number
 * @min 2
 * @desc
 * 多刀流で使う二つ目の武器スロット
 * ※装備タイプの盾のIDを設定してください。
 *
 * @param Weapon Slot 3
 * @text 多刀流・三つ目の武器スロット
 * @default 6
 * @type number
 * @min 2
 * @desc
 * 多刀流で使う三つ目の武器スロット
 * ※装備タイプの個数を越えない様にしてください
 *
 * @param Weapon Slot 4
 * @text 多刀流・四つ目の武器スロット
 * @default 9
 * @type number
 * @min 2
 * @desc
 * 多刀流で使う四つ目の武器スロット
 * ※装備タイプの個数を越えない様にしてください
 *
 * @param Shild Slot ID
 * @text ダブルシールド・本来の盾スロット
 * @default 2
 * @type number
 * @min 2
 * @desc
 * ダブルシールドで使う本来の盾スロット
 * ※装備タイプの盾のIDを設定してください。
 *
 * @param Shild Slot 2
 * @text ダブルシールド・二つ目の盾スロット
 * @default 3
 * @type number
 * @min 2
 * @desc
 * ダブルシールドで使う二つ目の盾スロット
 * ※装備タイプの個数を越えない様にしてください
 *
 * @param Acce Slot ID
 * @text 複数装飾品・本来の装飾品スロット
 * @default 6
 * @type number
 * @min 2
 * @desc
 * 複数装飾品で使う本来の装飾品スロット
 * ※装備タイプの装飾品のIDを設定してください。
 *
 * @param Acce Slot 2
 * @text 複数装飾品・二つ目の装飾品スロット
 * @default 7
 * @type number
 * @min 1
 * @desc
 * 複数装飾品で使う二つ目の装飾品スロット
 * ※装備タイプの個数を越えない様にしてください
 *
 * @help
 * 多刀流をはじめとした特殊装備詰め合わせです。
 * 
 * ・多刀流
 * 三刀流、四刀流を実装します。
 * 多刀流は二刀流からの拡張となります。
 * 例えばアクセサリで特徴にスロットタイプ：二刀流を付与した場合、
 * ここから三刀流にするためには data/Armors.json を改造します。
 * traits に {"code":55,"dataId":1,"value":1} の記載があると思うので
 * 三刀流の場合は dataId を 2 に、
 * 四刀流の場合は dataId を 3 に変更してください。
 * 
 * ・ダブルシールド
 * ユニコーンオーバー□ードのように盾を二つ装備可能にします。
 * こちらも多刀流と同様に data/Armors.json を改造します。
 * traits に {"code":56,"dataId":1,"value":1} を追加してください。
 * ※なお、デスティニーガンダムのようにトリプルシールド
 * （ソリドゥス・フルゴール×2 + 実体盾）も実装しようかと思いましたが
 * 流石に需要がないと思ったのでやめました。
 * （そもそもデスティニーガンダムはシールド3つ同時展開とかしねぇよ！）
 * 
 * ・装飾品を2個
 * 予め装備タイプに装飾品、装飾品2の2つを作成しておいてください。
 * ※データベース上、防具にて装飾品の装備タイプは元の装飾品として
 * 　作成してください。
 *
 * Java ScriptよりもRubyを使いたい！ by 貪藻矢射妥←
 * 
 * @url https://diamond.iza-yoi.net/
 */


var OuterFlg = OuterFlg || {};

(() => {

'use strict';

OuterFlg.imported = OuterFlg.imported || {};
OuterFlg.imported['MultiBlade'] = true;

var pluginParams = PluginManager.parameters('Change_MultiBlade_MZ');
var changeMultiBladeWepSlot2   = Number(pluginParams['Weapon Slot 2'] || 2);
var changeMultiBladeWepSlot3   = Number(pluginParams['Weapon Slot 3'] || 6);
var changeMultiBladeWepSlot4   = Number(pluginParams['Weapon Slot 4'] || 9);
var changeMultiBladeShildId    = Number(pluginParams['Shild Slot ID'] || 2);
var changeMultiBladeShildSlot2 = Number(pluginParams['Shild Slot 2'] || 3);
var changeMultiBladeAcceId     = Number(pluginParams['Acce Slot ID'] || 6);
var changeMultiBladeAcceSlot2  = Number(pluginParams['Acce Slot 2'] || 7);

//var ParamsEx             = PluginManagerEx.createParameter(document.currentScript);
//var ParamsEx_maxHoldList = ParamsEx['hogehogeStruct'];


// ダブルシールド
Game_BattlerBase.TRAIT_SLOT_TYPE2 = 56;

Game_BattlerBase.EQUIP_TYPE_WEAPON = 1;

//-----------------------------------------------------------------------------
// Game_BattlerBase

Game_BattlerBase.prototype.getMultiBlade = function() {
    return this.slotType();
};

Game_BattlerBase.prototype.slotType2 = function() {
    const set = this.traitsSet(Game_BattlerBase.TRAIT_SLOT_TYPE2);
    return set.length > 0 ? Math.max(...set) : 0;
};

Game_BattlerBase.prototype.isDualShild = function() {
    return this.slotType2() === 1;
};


//-----------------------------------------------------------------------------
// Game_Actor

Game_Actor.prototype.equipSlots = function() {
    const slots = [];
    for ( let i = 1; i < $dataSystem.equipTypes.length; i++ ) {
        slots.push(i);
    }
    
    // 複数装飾品
    if ( slots.length >= changeMultiBladeAcceSlot2 ) {
        slots[changeMultiBladeAcceSlot2 - 1] = changeMultiBladeAcceId;
    }
    
    // 多刀流
    if ( slots.length >= changeMultiBladeWepSlot2 && this.getMultiBlade() >= 1 ) {
        slots[changeMultiBladeWepSlot2 - 1] = Game_BattlerBase.EQUIP_TYPE_WEAPON;
    }
    if ( slots.length >= changeMultiBladeWepSlot3 && this.getMultiBlade() >= 2 ) {
        slots[changeMultiBladeWepSlot3 - 1] = Game_BattlerBase.EQUIP_TYPE_WEAPON;
    }
    if ( slots.length >= changeMultiBladeWepSlot4 && this.getMultiBlade() >= 3 ) {
        slots[changeMultiBladeWepSlot4 - 1] = Game_BattlerBase.EQUIP_TYPE_WEAPON;
    }
    
    // ダブルシールド
    if ( slots.length >= changeMultiBladeShildSlot2 && this.isDualShild() ) {
        slots[changeMultiBladeShildSlot2 - 1] = changeMultiBladeShildId;
    }
    
    return slots;
};


})();
